local E, L, V, P, G, _ =  unpack(ElvUI);
local DT = E:GetModule('DataTexts')

local lastPanel
local displayString = "---"
local _hex
local Lang = GetLocale()
local green = "|cff00ff00"
local orange = "|cffda8c4f"
local red = "|cffc74040"
local white = "|cffffffff"
local version = GetAddOnMetadata("ElvUI_LegionCurrencies", "Version")

local currencies = {1155, 1275, 1416, 1299, 1356, 1357, 1355, 1342, 1314, 1226, 1220, 1273, 1154, 1149, 1268, 1166, 1508}

V["ElvUI_LegionCurrencies"] = {
	-- misc
	["icons"] = true,
	["hidett"] = false,
	-- currencies
	[1155] = true, -- Ancient Mana, 1155
	[1275] = true, -- Curious Coin, 1275
	[1416] = true, -- Coins of Air, 1416
	[1299] = true, -- Brawlers Gold, 1299
	[1356] = true, -- Echoes of Battle, 1356
	[1357] = true, -- Echoes of Domination, 1357
	[1355] = true, -- Felessence, 1355
	[1342] = true, -- Legionfall War Supplies, 1342
	[1314] = true, -- Lingering Soul Fragment, 1314
	[1226] = true, -- Nethershard, 1226
	[1220] = true, -- Order Resources, 1220
	[1273] = true, -- Seal of Broken Fate, 1273
	[1154] = true, -- Shadowy Coins, 1154
	[1149] = true, -- Sightless Eye, 1149
	[1268] = true, -- Timeworn Artifact, 1268
	[1166] = true, -- Timewarped Badge, 1166
	[1508] = true, -- Veiled Argunite, 1508
--	[] = true, -- , 
--	[] = true, -- , 
--	[] = true, -- , 
--	[] = true, -- , 
}

local function setupDB() 
	E.private["ElvUI_LegionCurrencies"] = E.private["ElvUI_LegionCurrencies"] or {}
end

local function ToggleOption(name)
	if E.private["ElvUI_LegionCurrencies"][name] then
		E.private["ElvUI_LegionCurrencies"][name] = false
	else
		E.private["ElvUI_LegionCurrencies"][name] = true
	end
end

local function GetOption(name)
	if E.private["ElvUI_LegionCurrencies"][name] then
		return E.private["ElvUI_LegionCurrencies"][name]
	end
end

local menu = {
	{ text = L["Legion Currencies Options"], isTitle = true , notCheckable = true },
	{ text = L["Show"]..' '..L["Ancient Mana"], checked = function() return GetOption(1155) end, func = function() ToggleOption(1155) end },
	{ text = L["Show"]..' '..L["Curious Coin"], checked = function() return GetOption(1275) end, func = function() ToggleOption(1275) end },
	{ text = L["Show"]..' '..L["Coins of Air"], checked = function() return GetOption(1416) end, func = function() ToggleOption(1416) end },
	{ text = L["Show"]..' '..L["Bralwer's Gold"], checked = function() return GetOption(1299) end, func = function() ToggleOption(1299) end },
	{ text = L["Show"]..' '..L["Echoes of Battle"], checked = function() return GetOption(1356) end, func = function() ToggleOption(1356) end },
	{ text = L["Show"]..' '..L["Echoes of Domination"], checked = function() return GetOption(1357) end, func = function() ToggleOption(1357) end },
	{ text = L["Show"]..' '..L["Felessence"], checked = function() return GetOption(1355) end, func = function() ToggleOption(1355) end },
	{ text = L["Show"]..' '..L["Legionfall War Supplies"], checked = function() return GetOption(1342) end, func = function() ToggleOption(1342) end },
	{ text = L["Show"]..' '..L["Lingering Soul Farment"], checked = function() return GetOption(1314) end, func = function() ToggleOption(1314) end },
	{ text = L["Show"]..' '..L["Nethershard"], checked = function() return GetOption(1226) end, func = function() ToggleOption(1226) end },
	{ text = L["Show"]..' '..L["Order Resources"], checked = function() return GetOption(1220) end, func = function() ToggleOption(1220) end },
	{ text = L["Show"]..' '..L["Seal of Broken Fate"], checked = function() return GetOption(1273) end, func = function() ToggleOption(1273) end },
	{ text = L["Show"]..' '..L["Shadowy Coins"], checked = function() return GetOption(1154) end, func = function() ToggleOption(1154) end },
	{ text = L["Show"]..' '..L["Sightless Eye"], checked = function() return GetOption(1149) end, func = function() ToggleOption(1149) end },
	{ text = L["Show"]..' '..L["Timeworn Artifact"], checked = function() return GetOption(1268) end, func = function() ToggleOption(1268) end },
	{ text = L["Show"]..' '..L["Timewarped Badge"], checked = function() return GetOption(1166) end, func = function() ToggleOption(1166) end },
	{ text = L["Show"]..' '..L["Veiled Argunite"], checked = function() return GetOption(1508) end, func = function() ToggleOption(1508) end },
	{ text = " ", isTitle = true , notCheckable = true },
	{ text = L["Show icons"], checked = function() return GetOption("icons") end, func = function() ToggleOption("icons") end },
	{ text = L["Use ClassColor"], checked = function() return GetOption("cc") end, func = function() ToggleOption("cc") end },
	{ text = L["Hide Tooltip"], checked = function() return GetOption("hidett") end, func = function() ToggleOption("hidett") end },
}
local menuFrame = CreateFrame("Frame", "ElvUI_LegionCurrenciesDatatextMenuFrame", E.UIParent, 'UIDropDownMenuTemplate')

local function ColorValue(cap, currency)
	local color, percent
	if cap ~= 0 then percent = currency * (100 / cap)
	else percent = 0 end
	
	if percent < 70 then 
		if GetOption("cc") then color = _hex
		else color = white end
	elseif percent >= 70 and percent < 90 then color = orange
	elseif percent >= 90 then color = red end
	if cap == 0 then 
		if GetOption("cc") then return _hex
		else return white end
	else return color end 
	return _hex
end

local function OnEvent(self, event, ...)
	setupDB() 
	lastPanel = self
	local _text = "---"
	if not _hex then return end
	for i = 1, #(currencies) do
		if i == 1 then displayString = '' end
		local index = currencies[i]
		local name, count, icon, earnedThisWeek, weeklyMax, totalMax, isDiscovered = GetCurrencyInfo(index)
		if isDiscovered then
			if(i ~= 1) then _text = "  " else _text = "" end
			local texture = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', icon)
			if index == 1155 and GetOption(1155) then
				local str
				if GetOption("icons") then
					str = tostring(_text..texture..":"..ColorValue(totalMax, count)..count.."|r")
				else
					words = { strsplit(" ", name) }
					for _, word in ipairs(words) do _text = _text..string.sub(word,1,1) end
					str = tostring(_text..":"..ColorValue(totalMax, count)..count.."|r")
				end
				displayString = displayString..str
			end
			if index == 1275 and GetOption(1275) then
				local str
				if GetOption("icons") then
					str = tostring(_text..texture..":"..ColorValue(totalMax, count)..count.."|r")
				else
					words = { strsplit(" ", name) }
					for _, word in ipairs(words) do _text = _text..string.sub(word,1,1) end
					str = tostring(_text..":"..ColorValue(totalMax, count)..count.."|r")
				end
				displayString = displayString..str
			end
			if index == 1416 and GetOption(1416) then
				local str
				if GetOption("icons") then
					str = tostring(_text..texture..":"..ColorValue(totalMax, count)..count.."|r")
				else
					words = { strsplit(" ", name) }
					for _, word in ipairs(words) do _text = _text..string.sub(word,1,1) end
					str = tostring(_text..":"..ColorValue(totalMax, count)..count.."|r")
				end
				displayString = displayString..str
			end
			if index == 1299 and GetOption(1299) then
				local str
				if GetOption("icons") then
					str = tostring(_text..texture..":"..ColorValue(totalMax, count)..count.."|r")
				else
					words = { strsplit(" ", name) }
					for _, word in ipairs(words) do _text = _text..string.sub(word,1,1) end
					str = tostring(_text..":"..ColorValue(totalMax, count)..count.."|r")
				end
				displayString = displayString..str
			end
			if index == 1356 and GetOption(1356) then
				local str
				if GetOption("icons") then
					str = tostring(_text..texture..":"..ColorValue(totalMax, count)..count.."|r")
				else
					words = { strsplit(" ", name) }
					for _, word in ipairs(words) do _text = _text..string.sub(word,1,1) end
					str = tostring(_text..":"..ColorValue(totalMax, count)..count.."|r")
				end
				displayString = displayString..str
			end
			if index == 1357 and GetOption(1357) then
				local str
				if GetOption("icons") then
					str = tostring(_text..texture..":"..ColorValue(totalMax, count)..count.."|r")
				else
					words = { strsplit(" ", name) }
					for _, word in ipairs(words) do _text = _text..string.sub(word,1,1) end
					str = tostring(_text..":"..ColorValue(totalMax, count)..count.."|r")
				end
				displayString = displayString..str
			end
			if index == 1355 and GetOption(1355) then
				local str
				if GetOption("icons") then
					str = tostring(_text..texture..":"..ColorValue(totalMax, count)..count.."|r")
				else
					words = { strsplit(" ", name) }
					for _, word in ipairs(words) do _text = _text..string.sub(word,1,1) end
					str = tostring(_text..":"..ColorValue(totalMax, count)..count.."|r")
				end
				displayString = displayString..str
			end
			if index == 1342 and GetOption(1342) then
				local str
				if GetOption("icons") then
					str = tostring(_text..texture..":"..ColorValue(totalMax, count)..count.."|r")
				else
					words = { strsplit(" ", name) }
					for _, word in ipairs(words) do _text = _text..string.sub(word,1,1) end
					str = tostring(_text..":"..ColorValue(totalMax, count)..count.."|r")
				end
				displayString = displayString..str
			end
			if index == 1314 and GetOption(1314) then
				local str
				if GetOption("icons") then
					str = tostring(_text..texture..":"..ColorValue(totalMax, count)..count.."|r")
				else
					words = { strsplit(" ", name) }
					for _, word in ipairs(words) do _text = _text..string.sub(word,1,1) end
					str = tostring(_text..":"..ColorValue(totalMax, count)..count.."|r")
				end
				displayString = displayString..str
			end
			if index == 1226 and GetOption(1226) then
				local str
				if GetOption("icons") then
					str = tostring(_text..texture..":"..ColorValue(totalMax, count)..count.."|r")
				else
					words = { strsplit(" ", name) }
					for _, word in ipairs(words) do _text = _text..string.sub(word,1,1) end
					str = tostring(_text..":"..ColorValue(totalMax, count)..count.."|r")
				end
				displayString = displayString..str
			end
			if index == 1220 and GetOption(1220) then
				local str
				if GetOption("icons") then
					str = tostring(_text..texture..":"..ColorValue(totalMax, count)..count.."|r")
				else
					words = { strsplit(" ", name) }
					for _, word in ipairs(words) do _text = _text..string.sub(word,1,1) end
					str = tostring(_text..":"..ColorValue(totalMax, count)..count.."|r")
				end
				displayString = displayString..str
			end
			if index == 1273 and GetOption(1273) then
				local str
				if GetOption("icons") then
					str = tostring(_text..texture..":"..ColorValue(totalMax, count)..count.."|r")
				else
					words = { strsplit(" ", name) }
					for _, word in ipairs(words) do _text = _text..string.sub(word,1,1) end
					str = tostring(_text..":"..ColorValue(totalMax, count)..count.."|r")
				end
				displayString = displayString..str
			end
			if index == 1154 and GetOption(1154) then
				local str
				if GetOption("icons") then
					str = tostring(_text..texture..":"..ColorValue(totalMax, count)..count.."|r")
				else
					words = { strsplit(" ", name) }
					for _, word in ipairs(words) do _text = _text..string.sub(word,1,1) end
					str = tostring(_text..":"..ColorValue(totalMax, count)..count.."|r")
				end
				displayString = displayString..str
			end
			if index == 1149 and GetOption(1149) then
				local str
				if GetOption("icons") then
					str = tostring(_text..texture..":"..ColorValue(totalMax, count)..count.."|r")
				else
					words = { strsplit(" ", name) }
					for _, word in ipairs(words) do _text = _text..string.sub(word,1,1) end
					str = tostring(_text..":"..ColorValue(totalMax, count)..count.."|r")
				end
				displayString = displayString..str
			end
			if index == 1268 and GetOption(1268) then
				local str
				if GetOption("icons") then
					str = tostring(_text..texture..":"..ColorValue(totalMax, count)..count.."|r")
				else
					words = { strsplit(" ", name) }
					for _, word in ipairs(words) do _text = _text..string.sub(word,1,1) end
					str = tostring(_text..":"..ColorValue(totalMax, count)..count.."|r")
				end
				displayString = displayString..str
			end
			if index == 1166 and GetOption(1166) then
				local str
				if GetOption("icons") then
					str = tostring(_text..texture..":"..ColorValue(totalMax, count)..count.."|r")
				else
					words = { strsplit(" ", name) }
					for _, word in ipairs(words) do _text = _text..string.sub(word,1,1) end
					str = tostring(_text..":"..ColorValue(totalMax, count)..count.."|r")
				end
				displayString = displayString..str
			end
			if index == 1508 and GetOption(1508) then
				local str
				if GetOption("icons") then
					str = tostring(_text..texture..":"..ColorValue(totalMax, count)..count.."|r")
				else
					words = { strsplit(" ", name) }
					for _, word in ipairs(words) do _text = _text..string.sub(word,1,1) end
					str = tostring(_text..":"..ColorValue(totalMax, count)..count.."|r")
				end
				displayString = displayString..str
			end
		end
	end	
	if self then
		if displayString == '' or (not GetOption(1155) and not GetOption(1275) and not GetOption(1416) and not GetOption(1299) and not GetOption(1356) and not GetOption(1357) and not GetOption(1355) and not GetOption(1342) and not GetOption(1314) and not GetOption(1226) and not GetOption(1220) and not GetOption(1273) and not GetOption(1154) and not GetOption(1149) and not GetOption(1268) and not GetOption(1166) and not GetOption(1508)) then 
			displayString = tostring("ElvUI ".._hex..L["Legion"].." "..L["Currencies"].."|r") end
		self.text:SetFormattedText(displayString)
	end
end

local function getCurinfo(curID)
	local Name, Amount, Icon, WeeklyEarned, WeeklyMax, TotalMax, IsDiscovered = GetCurrencyInfo(curID)
	return {Name, Icon, Amount, WeeklyEarned, WeeklyMax, TotalMax, IsDiscovered}
end

local function ColorWeeklyText(WE, WM)
	local color;
	if WE < WM then color = green
	else color = red end
	return "("..color..WE.."/"..WM..white..")"
end

local function OnEnter(self)
	local hideTT = E.private["ElvUI_LegionCurrencies"]["hidett"]
	if hideTT or (UnitLevel('player') < 100) then
		DT.tooltip:Hide()
	else
		local r1, g1, b1, r2, g2, b2, r3, g3, b3 = HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, 0, 255, 0;
		DT:SetupTooltip(self)
		if UnitLevel('player') >= 100 then -- Legion
			if getCurinfo(1155)[7] then
				DT.tooltip:AddDoubleLine(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', getCurinfo(1155)[2]).." "..getCurinfo(1155)[1], getCurinfo(1155)[3].."/"..getCurinfo(1155)[6], r1, g1, b1, r1, g1, b1)
			end
			if getCurinfo(1275)[7] then
				DT.tooltip:AddDoubleLine(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', getCurinfo(1275)[2]).." "..getCurinfo(1275)[1], getCurinfo(1275)[3], r1, g1, b1, r1, g1, b1)
			end
			if getCurinfo(1416)[7] then
				DT.tooltip:AddDoubleLine(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', getCurinfo(1416)[2]).." "..getCurinfo(11416)[1], getCurinfo(1416)[3].."/"..getCurinfo(1416)[6], r1, g1, b1, r1, g1, b1)
			end
			if getCurinfo(1299)[7] then
				DT.tooltip:AddDoubleLine(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', getCurinfo(1299)[2]).." "..getCurinfo(1299)[1], getCurinfo(1299)[3].."/"..getCurinfo(1299)[6], r1, g1, b1, r1, g1, b1)
			end
			if getCurinfo(1356)[7] then
				DT.tooltip:AddDoubleLine(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', getCurinfo(1356)[2]).." "..getCurinfo(1356)[1], getCurinfo(1356)[3], r1, g1, b1, r1, g1, b1)
			end
			if getCurinfo(1357)[7] then
				DT.tooltip:AddDoubleLine(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', getCurinfo(1357)[2]).." "..getCurinfo(1357)[1], getCurinfo(1357)[3], r1, g1, b1, r1, g1, b1)
			end
			if getCurinfo(1355)[7] then
				DT.tooltip:AddDoubleLine(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', getCurinfo(1355)[2]).." "..getCurinfo(1355)[1], getCurinfo(1355)[3], r1, g1, b1, r1, g1, b1)
			end
			if getCurinfo(1342)[7] then
				DT.tooltip:AddDoubleLine(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', getCurinfo(1342)[2]).." "..getCurinfo(1342)[1], getCurinfo(1342)[3].."/"..getCurinfo(1342)[6], r1, g1, b1, r1, g1, b1)
			end
			if getCurinfo(1314)[7] then
				DT.tooltip:AddDoubleLine(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', getCurinfo(1314)[2]).." "..getCurinfo(1314)[1], ColorWeeklyText(getCurinfo(1314)[4], getCurinfo(1314)[5]).." "..getCurinfo(1314)[3].."/"..getCurinfo(1314)[6], r1, g1, b1, r1, g1, b1)
			end
			if getCurinfo(1226)[7] then
				DT.tooltip:AddDoubleLine(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', getCurinfo(1226)[2]).." "..getCurinfo(1226)[1], getCurinfo(1226)[3], r1, g1, b1, r1, g1, b1)
			end
			if getCurinfo(1220)[7] then
				DT.tooltip:AddDoubleLine(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', getCurinfo(1220)[2]).." "..getCurinfo(1220)[1], getCurinfo(1220)[3], r1, g1, b1, r1, g1, b1)
			end
			if getCurinfo(1273)[7] then
				DT.tooltip:AddDoubleLine(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', getCurinfo(1273)[2]).." "..getCurinfo(1273)[1], getCurinfo(1273)[3].."/"..getCurinfo(1273)[6], r1, g1, b1, r1, g1, b1)
			end
			if getCurinfo(1154)[7] then
				DT.tooltip:AddDoubleLine(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', getCurinfo(1154)[2]).." "..getCurinfo(1154)[1], getCurinfo(1154)[3].."/"..getCurinfo(1154)[6], r1, g1, b1, r1, g1, b1)
			end
			if getCurinfo(1149)[7] then
				DT.tooltip:AddDoubleLine(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', getCurinfo(1149)[2]).." "..getCurinfo(1149)[1], getCurinfo(1149)[3].."/"..getCurinfo(1149)[6], r1, g1, b1, r1, g1, b1)
			end
			if getCurinfo(1268)[7] then
				DT.tooltip:AddDoubleLine(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', getCurinfo(1268)[2]).." "..getCurinfo(1268)[1], getCurinfo(1268)[3].."/"..getCurinfo(1268)[6], r1, g1, b1, r1, g1, b1)
			end
			if getCurinfo(1166)[7] then
				DT.tooltip:AddDoubleLine(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', getCurinfo(1166)[2]).." "..getCurinfo(1166)[1], getCurinfo(1166)[3], r1, g1, b1, r1, g1, b1)
			end
			if getCurinfo(1508)[7] then
				DT.tooltip:AddDoubleLine(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', getCurinfo(1508)[2]).." "..getCurinfo(1508)[1], getCurinfo(1508)[3].."/"..getCurinfo(1508)[6], r1, g1, b1, r1, g1, b1)
			end
			DT.tooltip:AddLine("  ")
		end
		DT.tooltip:AddDoubleLine(L["rightM"], L["options"], r1, g1, b1, r2, g2, b2)
		DT.tooltip:AddDoubleLine(L["Shift"].." + "..L["rightM"], L["ClassHall Report"], r1, g1, b1, r2, g2, b2)
		DT.tooltip:Show()
	end 
	if lastPanel ~= nil then
		OnEvent(lastPanel)
	end
end


--[[
local function OnEnter(self)
	local r1, g1, b1, r2, g2, b2 = HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b;
	DT:SetupTooltip(self)
	if UnitLevel("player") >= 100 then
		DT.tooltip:AddDoubleLine(L["Right-Click"]..":", L["Datatext Options Menu"], r1, g1, b1, r2, g2, b2)
		DT.tooltip:Show()
	else
		DT.tooltip:Hide()
	end
	if lastPanel ~= nil then
		OnEvent(lastPanel)
	end
end ]]

local function OnClick(self, btn)
	if UnitLevel("player") >= 100 then
		if btn == "RightButton" then
			DT.tooltip:Hide();
			if IsShiftKeyDown() then
				ShowGarrisonLandingPage(LE_GARRISON_TYPE_7_0)
			else
				EasyMenu(menu, menuFrame, self, 0, 100, 'MENU', 3)
			end
--		else if btn == "LeftButton" then
--			if IsControlKeyDown() then
--				ToggleCharacter(TokenFrame)
--			end
		end
	end
end

local function ValueColorUpdate(hex, r, g, b)
	_hex = hex
	if lastPanel ~= nil then
		OnEvent(lastPanel)
	end
end
E['valueColorUpdateFuncs'][ValueColorUpdate] = true

--[[
	DT:RegisterDatatext(name, events, eventFunc, updateFunc, clickFunc, onEnterFunc)

	name - name of the datatext (required)
	events - must be a table with string values of event names to register
	eventFunc - function that gets fired when an event gets triggered
	updateFunc - onUpdate script target function
	click - function to fire when clicking the datatext
	onEnterFunc - function to fire OnEnter
]]
DT:RegisterDatatext("Legion Currencies", {"PLAYER_LOGIN", "PLAYER_ENTERING_WORLD", "PLAYER_MONEY", "PLAYER_TRADE_MONEY", "TRADE_MONEY_CHANGED", "SPELLS_CHANGED"}, OnEvent, nil, OnClick, OnEnter) hooksecurefunc("BackpackTokenFrame_Update", function(...) OnEvent(lastPanel) end)
